#define F_trigPin PIN_PC5// define the pins of your sensor
#define F_echoPin PIN_PC4
#define L_trigPin PIN_PC3
#define L_echoPin PIN_PC2
#define R_trigPin PIN_PB4
#define R_echoPin PIN_PB5
#define motorA_1 PIN_PD5
#define motorA_2 PIN_PD6
#define motorB_1 PIN_PB1
#define motorB_2 PIN_PB2

const int limdis = 26;
const int sidedis = 12;
const int turntime = 600;//(millisec)

int distance;
int thereis;
int turndirection;
int choice;
int leftscanval, centerscanval, rightscanval;

void setup(){
  // put your setup code here, to run once:
  pinMode(motorA_1,OUTPUT);
  pinMode(motorA_2,OUTPUT);
  pinMode(motorB_1,OUTPUT);
  pinMode(motorB_2,OUTPUT);
  pinMode(F_trigPin, OUTPUT);// set the trig pin to output (Send sound waves)
  pinMode(F_echoPin, INPUT);// set the echo pin to input (recieve sound waves)
  pinMode(R_trigPin, OUTPUT);// set the trig pin to output (Send sound waves)
  pinMode(R_echoPin, INPUT);// set the echo pin to input (recieve sound waves)
  pinMode(L_trigPin, OUTPUT);// set the trig pin to output (Send sound waves)
  pinMode(L_echoPin, INPUT);// set the echo pin to input (recieve sound waves)
  analogWrite(motorA_1,0);
  analogWrite(motorA_2,0);
  analogWrite(motorB_2,0);
  analogWrite(motorB_1,0);
  digitalWrite(F_trigPin, LOW);
  digitalWrite(R_trigPin, LOW);
  digitalWrite(L_trigPin, LOW);
}


//////////////////////////////////Move/////////////////////////////
void FW(){
  analogWrite(motorA_2,0);
  analogWrite(motorA_1,200);
  analogWrite(motorB_1,0);
  analogWrite(motorB_2,200);
}

void BW(){
  analogWrite(motorA_1,0);
  analogWrite(motorA_2,200);
  analogWrite(motorB_2,0);
  analogWrite(motorB_1,200);
}


void TR(){
  analogWrite(motorA_2,170);
  analogWrite(motorA_1,0);
  analogWrite(motorB_1,0);
  analogWrite(motorB_2,170);
  delay(turntime);
}

void TL(){
  analogWrite(motorA_2,0);
  analogWrite(motorA_1,170);
  analogWrite(motorB_1,170);
  analogWrite(motorB_2,0);
  delay(turntime);
}

void SM(){
  analogWrite(motorA_1,0);
  analogWrite(motorA_2,0);
  analogWrite(motorB_2,0);
  analogWrite(motorB_1,0);
}

////////////////////////////////Ultrasonic/////////////////////////
int F_US(){
  long howfar;
  digitalWrite(F_trigPin, LOW);  
  delayMicroseconds(5); // delays are required for a succesful sensor operation.
  digitalWrite(F_trigPin, HIGH);
  delayMicroseconds(15); //this delay is required as well!
  digitalWrite(F_trigPin, LOW);
  howfar=pulseIn(F_echoPin,HIGH);
  howfar=howfar*0.01657; //how far away is the object in cm
  return round(howfar);
}

int L_US(){
  long howfar;
  digitalWrite(L_trigPin, LOW);  
  delayMicroseconds(5); // delays are required for a succesful sensor operation.
  digitalWrite(L_trigPin, HIGH);
  delayMicroseconds(15); //this delay is required as well!
  digitalWrite(L_trigPin, LOW);
  howfar=pulseIn(L_echoPin,HIGH);
  howfar=howfar*0.01657; //how far away is the object in cm
  return round(howfar);
}

int R_US(){
  long howfar;
  digitalWrite(R_trigPin, LOW);  
  delayMicroseconds(5); // delays are required for a succesful sensor operation.
  digitalWrite(R_trigPin, HIGH);
  delayMicroseconds(15); //this delay is required as well!
  digitalWrite(R_trigPin, LOW);
  howfar=pulseIn(R_echoPin,HIGH);
  howfar=howfar*0.01657; //how far away is the object in cm
  return round(howfar);
}

void watcharound(){
  centerscanval = F_US();
  if(centerscanval<limdis){SM();}
  delay(100);
  leftscanval = L_US();
  if(leftscanval<sidedis){SM();}
  delay(100);
  rightscanval = R_US();
  if(rightscanval<sidedis){SM();}
  delay(300);
}

///////////////////////////////////Auto////////////////////////////////////////
int autopilot(){
  watcharound();
  if (leftscanval>rightscanval && leftscanval>centerscanval){
    choice = '1';
  }
  else if (rightscanval>leftscanval && rightscanval>centerscanval){
    choice = '2';
  }
  else{
    choice = '3';
  }
  return choice;
}

///////////////////////////////////LOOP////////////////////////////////////////
void loop() {
  FW();
  distance = F_US(); 
  if (distance<limdis){
      ++thereis;}
  if (distance>limdis){
      thereis=0;} //Count is restarted
  if (thereis > 25){
    SM(); // Since something is ahead, stop moving.
    turndirection = autopilot(); //Decide which direction to turn.
    switch (turndirection){
      case '1':
        TL();
        break;
      case '2':
        TR();
        break;
      case '3':
        ; //Do not turn if there was actually nothing ahead
        break;
    }
    thereis=0;
  }
}
